var req = new ActiveXObject ("MSXML2.ServerXMLHTTP");

var invalidlocktoken = "DAV:no-lock";
// var invalidlocktoken = "opaquelocktoken:00000000-0000-0000-0000-000000000000";

var uri = WScript.Arguments(0);
var user = null;
var pwd = null;

if (WScript.Arguments.length > 1) {
  user = WScript.Arguments(1);
}

if (WScript.Arguments.length > 2) {
	pwd = WScript.Arguments(2);
}

function getetag(req) {
  // first check response header
  var etag = req.getResponseHeader("etag");
  
  if (etag == null || etag == "") {
  
    var req2 = new ActiveXObject ("MSXML2.ServerXMLHTTP");
    // otherwise try HEAD
    req2.open("HEAD", uri, false, user, pwd);
    req2.send();
  
    if (req2.status < 200 || req2.status >= 300) {
      WScript.Echo("unexpected status upon HEAD: " + req.status);
      WScript.Quit(2);
    }
  
    etag = req2.getResponseHeader("etag");
    if (etag == null || etag == "") {
      WScript.Echo("HEAD did not return etag");
      WScript.Quit(2);
    }
  }
  
  WScript.Echo("etag is: " + etag);
  
  return etag;  
}

function testcase(req, num, ifheader, expect) {
  req.setRequestHeader("x-greenbytes", "If header test# " + num + ", header: " + ifheader + ", expect " + expect);
  req.setRequestHeader("if", ifheader);
  WScript.Echo();
  WScript.Echo("If header test #" + num + ", header: " + ifheader + ", expect " + expect);
}

// put content
req.open("PUT", uri, false, user, pwd);
req.send("foobar");

if (req.status < 200 || req.status >= 300) {
  WScript.Echo("unexpected status upon PUT: " + req.status + " " + req.responseText);
  WScript.Quit(2);
}

var etag = getetag(req);

req.open("LOCK", uri, false, user, pwd);
req.setRequestHeader("Depth", "0");
req.setRequestHeader("Timeout", "Second-60");
req.send("<D:lockinfo xmlns:D='DAV:'><D:lockscope><D:exclusive/></D:lockscope><D:locktype><D:write/></D:locktype></D:lockinfo>");

var locktoken = req.getResponseHeader("lock-token");

if (locktoken == null || locktoken == "") {
  WScript.Echo("server did not return lock token, trying response body");
  WScript.Echo(req.responseText);
  req.responseXML.setProperty("SelectionLanguage", "XPath");
  locktoken = req.responseXML.selectSingleNode("//*[local-name()='href']").text;
}
else {
  locktoken = locktoken.substring(1, locktoken.length - 1);
}

if (req.status == 200 || req.status == 201) {
  WScript.Echo("locktoken: " + locktoken);
}
else {
  WScript.Echo("resource not locked, status: " + req.status + " " + req.responseText);
  WScript.Quit(2);
}

var cnt = 0;
var ifheader;

// try PUTs while locked

req.open("PUT", uri, false, user, pwd);
ifheader = "(<" + locktoken + ">)";
testcase(req, ++cnt, ifheader, "pass"); 
req.send("foobar2dsdssssssssssssssssss");


if (req.status < 200 || req.status >= 300) {
  WScript.Echo("unexpected status upon second PUT: " + req.status + " " + req.responseText);
}

etag = getetag(req);


req.open("PUT", uri, false, user, pwd);
ifheader = "(<" + locktoken + "> ["+etag+"])";
testcase(req, ++cnt, ifheader, "pass");
req.send("foobar2");

if (req.status < 200 || req.status >= 300) {
  WScript.Echo("unexpected status upon third PUT: " + req.status + " " + req.responseText);
}

etag = getetag(req);


req.open("PUT", uri, false, user, pwd);
ifheader = "(<" + "DAV-nolock" + "> ["+etag+"])";
testcase(req, ++cnt, ifheader, "fail");
req.send("foobar2");

if (req.status >= 200 && req.status < 300) {
  WScript.Echo("4th PUT should fail but succeeded: " + req.status + " " + req.responseText);
  etag = getetag(req);
}


req.open("PUT", uri, false, user, pwd);
ifheader = "(<" + locktoken + ">) (Not <"+invalidlocktoken+">)";
testcase(req, ++cnt, ifheader, "pass");
req.send("foobar2");

if (req.status < 200 || req.status >= 300) {
  WScript.Echo("unexpected status upon  PUT: " + req.status + " " + req.responseText);
}

etag = getetag(req);


req.open("PUT", uri, false, user, pwd);
ifheader = "(<" + locktoken + "x>) (Not<"+invalidlocktoken+">)";
testcase(req, ++cnt, ifheader, "fail");
req.send("foobar2");

if (req.status >= 200 && req.status < 300) {
  WScript.Echo("PUT should fail but succeeded: " + req.status + " " + req.responseText);
  etag = getetag(req);
}


// this is the special case where you want to succeed if th etag matches
// and your lock is still valid or gone
req.open("PUT", uri, false, user, pwd);
ifheader = "(<" + locktoken + "> ["+etag+"]) (Not<"+invalidlocktoken+"> ["+etag+"])";
testcase(req, ++cnt, ifheader, "pass");
req.send("foobar2");

if (req.status < 200 || req.status >= 300) {
  WScript.Echo("unexpected status upon PUT: " + req.status + " " + req.responseText);
}

etag = getetag(req);


req.open("PUT", uri, false, user, pwd);
ifheader = "(<" + locktoken + "> ["+etag+"x]) (Not<"+invalidlocktoken+"> ["+etag+"x])";
testcase(req, ++cnt, ifheader, "fail");
req.send("foobar2");

if (req.status >= 200 && req.status < 300) {
  WScript.Echo("PUT should fail but succeeded: " + req.status + " " + req.responseText);
  etag = getetag(req);
}


